﻿using Syncfusion.Data;
using Syncfusion.WinForms.DataGrid;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Windows.Forms;

namespace AdvFilterWF
{
    public partial class Form1 : Form
    {
        DataTable employeeCollection;
        public Form1()
        {
            InitializeComponent();
            
            var table = this.GetDataTable();
            sfDataGrid1.LiveDataUpdateMode = LiveDataUpdateMode.AllowSummaryUpdate;
            sfDataGrid1.DataSource = table;

            // Creates the TableSummaryRow for (Sum of 1111) subtotal 
            GridTableSummaryRow tableSummaryRow1 = new GridTableSummaryRow();
            tableSummaryRow1.Name = "FirstSubTotalSummary";
            tableSummaryRow1.ShowSummaryInRow = false;

            // Creates the TableSummaryRow for (Sum of 2222) subtotal 
            GridTableSummaryRow tableSummaryRow2 = new GridTableSummaryRow();
            tableSummaryRow2.Name = "SecondSubTotalSummary";
            tableSummaryRow2.ShowSummaryInRow = false;

            // Creates the TableSummaryRow for total
            GridTableSummaryRow tableSummaryRow3 = new GridTableSummaryRow();
            tableSummaryRow3.Name = "TotalSummary";
            tableSummaryRow3.ShowSummaryInRow = false;


            // Creates the GridSummaryColumn for (Sum of 1111) subtotal 
            GridSummaryColumn summaryColumn1 = new GridSummaryColumn();
            summaryColumn1.Name = "SubTotalX";
            //subtotal for X column
            summaryColumn1.MappingName = "X";
            summaryColumn1.SummaryType = SummaryType.Custom;
            // Initialize the CustomAggregate.
            summaryColumn1.CustomAggregate = new CustomAggregate();
            summaryColumn1.Format = "1111 Sum = {FirstSumX}";

            GridSummaryColumn summaryColumn2 = new GridSummaryColumn();
            summaryColumn2.Name = "SubTotalY";
            //subtotal for Y column
            summaryColumn2.MappingName = "Y";
            summaryColumn2.SummaryType = SummaryType.Custom;
            // Initialize the CustomAggregate.
            summaryColumn2.CustomAggregate = new CustomAggregate();
            summaryColumn2.Format = "{FirstSumY}";


            // Creates the GridSummaryColumn for (Sum of 2222) subtotal 
            GridSummaryColumn summaryColumn3 = new GridSummaryColumn();
            summaryColumn3.Name = "SubTotalX";
            //subtotal for X column
            summaryColumn3.MappingName = "X";
            summaryColumn3.SummaryType = SummaryType.Custom;
            // Initialize the CustomAggregate.
            summaryColumn3.CustomAggregate = new CustomAggregate();
            summaryColumn3.Format = "2222 Sum = {SecondSumX}";

            GridSummaryColumn summaryColumn4 = new GridSummaryColumn();
            summaryColumn4.Name = "SubTotalY";
            //subtotal for Y column
            summaryColumn4.MappingName = "Y";
            summaryColumn4.SummaryType = SummaryType.Custom;
            // Initialize the CustomAggregate.
            summaryColumn4.CustomAggregate = new CustomAggregate();
            summaryColumn4.Format = "{SecondSumY}";


            // Creates the GridSummaryColumn for total
            GridSummaryColumn summaryColumn5 = new GridSummaryColumn();
            summaryColumn5.Name = "Total";
            summaryColumn5.SummaryType = SummaryType.DoubleAggregate;
            summaryColumn5.Format = "Total = {Sum}";
            //total for X column
            summaryColumn5.MappingName = "X";

            GridSummaryColumn summaryColumn6 = new GridSummaryColumn();
            summaryColumn6.Name = "Total";
            summaryColumn6.SummaryType = SummaryType.DoubleAggregate;
            summaryColumn6.Format = "{Sum}";
            //total for Y column
            summaryColumn6.MappingName = "Y";

            // Adds the GridSummaryColumn in the SummaryColumns collection.
            //Here add the GridSummaryColumn for (Sum of 1111) subtotal 
            tableSummaryRow1.SummaryColumns.Add(summaryColumn1);
            tableSummaryRow1.SummaryColumns.Add(summaryColumn2);

            //Here add the GridSummaryColumn for (Sum of 2222) subtotal 
            tableSummaryRow2.SummaryColumns.Add(summaryColumn3);
            tableSummaryRow2.SummaryColumns.Add(summaryColumn4);

            //Here add the GridSummaryColumn for total
            tableSummaryRow3.SummaryColumns.Add(summaryColumn5);
            tableSummaryRow3.SummaryColumns.Add(summaryColumn6);

            // Adds the GridTableSummaryRow in the TableSummaryRows collection.
            this.sfDataGrid1.TableSummaryRows.Add(tableSummaryRow1);
            this.sfDataGrid1.TableSummaryRows.Add(tableSummaryRow2);
            this.sfDataGrid1.TableSummaryRows.Add(tableSummaryRow3);
        }        

        public DataTable GetDataTable()
        {
            employeeCollection = new DataTable();

            employeeCollection.Columns.Add("SSZ", typeof(int));
            employeeCollection.Columns.Add("Text", typeof(string));
            employeeCollection.Columns.Add("X", typeof(int));            
            employeeCollection.Columns.Add("Y", typeof(int));  

            employeeCollection.Rows.Add(1111, "Maria Anders", 1, 10);
            employeeCollection.Rows.Add(2222, "Ana Trujilo", 2, 11);
            employeeCollection.Rows.Add(1111, "Antonio Moreno", 3, 12);
            employeeCollection.Rows.Add(1111, "Thomas Hardy", 4,  13);
            employeeCollection.Rows.Add(2222, "Christina Berglund", 5,  14);
            employeeCollection.Rows.Add(2222, "Hanna Moos",6,  15);           

            return employeeCollection;

        }        
    }

    public class CustomAggregate : ISummaryAggregate
    {
        public CustomAggregate()
        {
        }

        public object StdDev { get; set; }

        public object FirstSumX { get; set; }

        public object FirstSumY { get; set; }

        public object SecondSumX { get; set; }

        public object SecondSumY { get; set; }

        Action<IEnumerable, string, PropertyDescriptor> ISummaryAggregate.CalculateAggregateFunc()
        {
            return (items, property, pd) =>
            {
                var enumerableItems = items as IEnumerable<DataRowView>;
                
                //here customize based on your scenario
                
                if (pd.Name == "FirstSumX")
                {
                    //here pass the specific column name to calculate sum
                    this.FirstSumX = enumerableItems.FirstSum<DataRowView>(q => q.Row["X"]);
                }

                if (pd.Name == "SecondSumX")
                {
                    //here pass the specific column name to calculate sum
                    this.SecondSumX = enumerableItems.SecondSum<DataRowView>(q => q.Row["X"]);
                }

                if (pd.Name == "FirstSumY")
                {
                    //here pass the specific column name to calculate sum
                    this.FirstSumY = enumerableItems.FirstSum<DataRowView>(q => q.Row["Y"]);
                }

                if (pd.Name == "SecondSumY")
                {
                    //here pass the specific column name to calculate sum
                    this.SecondSumY = enumerableItems.SecondSum<DataRowView>(q => q.Row["Y"]);
                }
            };
        }        
    }

    public static class LinqExtensions
    {
        public static object FirstSum<T>(this IEnumerable<T> values, Func<T, object> selector)
        {
            object result = 0;
            var count = values.Count();
            if (count > 0)
            {
                //here customize the collection based on custom condition
                var firstCollection = values.Where(x => (x as DataRowView).Row["SSZ"].ToString() == "1111");
                
                double sum = firstCollection.Select(selector).Sum(d => 
                {                    
                    if (d != null)
                    {
                        return Convert.ToDouble(d);
                    }
                    return 0.0;
                });

                result = sum;

            }
            return result;
        }


        public static object SecondSum<T>(this IEnumerable<T> values, Func<T, object> selector)
        {
            object result = 0;
            var count = values.Count();
            if (count > 0)
            {
                //here customize the collection based on custom condition
                var secondCollection = values.Where(x => (x as DataRowView).Row["SSZ"].ToString() == "2222");

                double sum = secondCollection.Select(selector).Sum(d =>
                {
                    if (d != null)
                    {
                        return Convert.ToDouble(d);
                    }
                    return 0.0;
                });

                result = sum;

            }
            return result;
        }
    }
}
